<?php
namespace Claromentis\Search;

$GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"] = (@$GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"] ?: array()) + array("_c8d1809bdc783b" . "9698165309fe704" . "327" => base64_decode("VGhlIHNlY29uZCBwYXJhbWV0ZXIg" . "b2Yg"), "_075c6c4172eaf58cfa8482" . "8a3582d19a" => base64_decode("YXJyYXlfdW5p" . "cXVl"), "_6fd29f1ce82d5e2d09" . "a2d806c2e2b1d5" => base64_decode("aXNfY2FsbG" . "FibGU="), "_5306cb5e8985434a2a638b90f897940" . "d" => base64_decode("IGlzIG" . "5vdCBj" . "YWxsYW" . "JsZQ=="), "_d706c160e45bf7434ff" . "f82a5976f0e19" => base64_decode("YXJyYXlfa2" . "V5cw=="), "_f73dab606630b388645c4f7d3f" . "bb13bb" => base64_decode("YXJyYXlfbWV" . "yZ2U="), "_8f7dd777fdeec4a63087" . "bff8b5c757bf" => base64_decode("VW5zdXBwb3J0ZWQgb2JqZWN" . "0IHR5cGUgLSA="));
use Claromentis\Search\Exception\UnsupportedItemTypeException;
use ErrorHandler;
use Exception;
use Claromentis\Search\Indexing\Exception\IndexingException;




class ItemTypeFactory extends ErrorHandler
{
    
    
    
    
    protected $search_item_types = array();
    
    
    
    
    protected $indexing_types = array();
    
    
    
    
    
    
    public function __construct()
    {
        $_a56d3cb9419f5f513e6d57bbcaaf3397 = new Config\Applications();
        $_f3e72c5e54a6dd0fb5c5005cd9574e42 = $_a56d3cb9419f5f513e6d57bbcaaf3397->GetAll();
        foreach ($_f3e72c5e54a6dd0fb5c5005cd9574e42 as $_f44467aacb8a4520c7382769d24aa422) {
            $this->RegisterApplication($_f44467aacb8a4520c7382769d24aa422);
        }
        
        
        
        
        
        
        
        
        \ClaPlugins::I()->RegisterIndexingObjectType($this);
    }
    
    
    
    
    
    
    public function RegisterApplication(Application\ApplicationInterface $_f44467aacb8a4520c7382769d24aa422)
    {
        $_17728688d370dbb69c53d9e641c4b0e0 = $_f44467aacb8a4520c7382769d24aa422->GetTypes();
        foreach ($_17728688d370dbb69c53d9e641c4b0e0 as $type => $_ef7e3c851590d142b4d780e7b9043897) {
            $this->RegisterType($type, $_ef7e3c851590d142b4d780e7b9043897);
        }
    }
    
    
    
    
    
    
    
    public function RegisterType($type, $_06e5839e14e1bc203f750e67ef402284)
    {
        if (!$GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_6fd29f1ce82d5e2d09a2d806c2e" . "2b1d5"]($_06e5839e14e1bc203f750e67ef402284)) {
            throw new IndexingException($GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_c8d1809bdc783b9698165309fe70432" . "7"] . __METHOD__ . $GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_5306cb5e8985434a2a638b90" . "f897940d"], 1);
        }
        $this->search_item_types[$type] = $_06e5839e14e1bc203f750e67ef402284;
    }
    
    
    
    
    
    
    
    public function Get($type)
    {
        if (isset($this->search_item_types[$type])) {
            return $this->search_item_types[$type]();
        } else {
            $e = new UnsupportedItemTypeException($GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_8f7dd777fdeec4a6" . "3087bff8b5c757bf"] . $type);
            $e->item_type = $type;
            throw $e;
        }
    }
    
    
    
    
    
    
    public function GetAllIndexingTypes()
    {
        return $GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_075c6c4172eaf58cfa8" . "4828a3582d19a"]($GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_f73dab606630b388645c4f7d" . "3fbb13bb"]($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_d706c16" . "0e45bf74" . "34fff82a" . "5976f0e1" . "9"]($this->search_item_types), $GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_d706c160e45bf7434fff82a5976" . "f0e19"]($this->indexing_types)));
    }
    
    
    
    
    
    
    
    public function RegisterIndexingType($_90a9b1825557bb7e0aff3dc1a7962296, $_06e5839e14e1bc203f750e67ef402284)
    {
        if (!$GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_6fd29f1ce82d5e2d09a2d806c" . "2e2b1d5"]($_06e5839e14e1bc203f750e67ef402284)) {
            throw new IndexingException($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_c8d1809b" . "dc783b969" . "8165309fe" . "704327"] . __METHOD__ . $GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_5306cb5e8985434a2a638b90f89794" . "0d"], 1);
        }
        $this->indexing_types[$_90a9b1825557bb7e0aff3dc1a7962296] = $_06e5839e14e1bc203f750e67ef402284;
    }
    
    
    
    
    
    
    public function GetIndexingObject($type)
    {
        if (isset($this->indexing_types[$type])) {
            $_68ffaaa31e3ba49ed9d6159fbee9f043 = $this->indexing_types[$type]();
            return $_68ffaaa31e3ba49ed9d6159fbee9f043;
        } else {
            return $this->Get($type)->GetIndexingObject();
        }
    }
}